import turtle


# importujemy moduł turtle


def rozetka(x, y, a, kolory):
    # tworzymy funkcję o nazwie rozetka
    # funkcja ta przyjmuje cztery argumenty
    # pierwsze dwa określają, gdzie ma zostać narysowana 
    # rozeta, kolejny argument określa rozmiar boku rombu 
    # ostatni argument to lista kolorów rombów
    turtle.penup()
    # podnosimy żółwia, od tej pory
    # poruszając się, nie pozostawia za
    # sobą śladu w postaci linii
    turtle.goto(x, y)
    # przemieszczamy żółwia do wskazanej pozycji
    # określonej przez zmienne x oraz y
    turtle.pendown()
    # opuszczamy żółwia, od tej pory
    # poruszając się, pozostawia za
    # sobą ślad w postaci linii
    turtle.setheading(0)
    # ustawiamy kierunek żółwia na wartość zero
    # ustawienie to powoduje, że żółw będzie skierowany w prawo
    turtle.left(7.5)
    # obracamy żółwia o 7,5 stopnia w lewo 
    for i in range(6):
        # pętla wykona się sześć razy
        turtle.fillcolor(kolory[i % len(kolory)])
        # ustawiamy kolor wypełnienia jako kolejny element 
        # listy kolory przekazanej jako argument do funkcji 
        # kolory będą wybierane cyklicznie 
        turtle.begin_fill()
        # rozpoczynamy wypełnianie
        for _ in range(2):
            # pętla wykona się dwa razy
            turtle.forward(a)
            # przesuwamy żółwia o wartość zmiennej a do przodu 
            turtle.left(45)
            # obracamy żółwia o 45 stopni w lewo 
            turtle.forward(a)
            # przesuwamy żółwia o wartość zmiennej a do przodu 
            turtle.left(135)
            # obracamy żółwia o 135 stopni w lewo
        # powyższa pętla odpowiedzialna jest za rysowanie 
        # pojedynczego rombu
        turtle.end_fill()
        # kończymy wypełnianie figury
        turtle.left(60)
        # obracamy żółwia o 60 stopni w lewo


rozetka(0, 0, 50, ["orange", "green"])
rozetka(200, 200, 50, ["orange", "green"])
rozetka(200, -200, 50, ["orange", "green"])
rozetka(-200, 200, 50, ["orange", "green"])
rozetka(-200, -200, 50, ["orange", "green"])
# funkcja rozetka zostaje wywołana pięć razy
# każde kolejne wywołanie różni się pozycją, 
# gdzie ma zostać narysowana rozeta


turtle.mainloop()
# zapobiegamy zamknięciu się okna 
# po zakończeniu rysowania
